#!/usr/bin/perl


                         ### *** IMPORTANT *** ###

       ### *** Make sure the path to PERL above is correct *** ###


       ########################################################### 
       # Signup Program                                          #
       # Script name - dir_setup.pl                              #
       # Written by Ranson Johnson - Email  ranson@rlaj.com      #
       # Version 2.0                                             #
       # Copyright 1997 by Ranson's Scripts all rights reserved  #
       ###########################################################

                      ### *** IMPORTANT *** ###

### *** If FTP'ing this file, be sure to send in ASCII format *** ###


             ### *** Configure the Variables Below *** ###

# Enter the root path for the data directory
$rootpath = '/usr/var/www/docs/ezhtml/program/directory/data';

# Enter the Web Address of the directory.cgi
$directory_cgi = 'http://www.ezhtml.com/program/directory/directory.cgi';

# Enter the Web Address of the listing.cgi
$listing_cgi = 'http://www.ezhtml.com/program/directory/listing.cgi';

# Enter the Web Address of the logo for the top of all pages
$logo = 'http://www.ezhtml.com/homeimages/ezhtml2.gif';

# Enter the Web Address of the clickable gif for all pages
# This is used for a link to the listing.cgi - for users to list their site
$Listing_Link = 'http://www.ezhtml.com/program/directory/list.gif';

# Enter the linit you want to put on the length of the description 
# for teh entry.
$desc_limit = '200';

# Enter the Title for your pages
$title = 'Welcome to EZHTML.COM';

# Enter the BODY Tag parameters for your pages
$Body = '<BODY TEXT="#000040" BGCOLOR="#F7FEFF" LINK="#0000DB" VLINK="#0000B3" ALINK="#FF0000" BACKGROUND="homeimages/frame_bg.gif">';

# Enter the Table Background Color for The DropDown List
$TableBg = 'BGCOLOR=#A4A4FF';




# Below, enter your categories and file names in the following format:
# "Category,filename",
# Put only one per line - make sure you have all quotes and commas in the
# proper places, or you will get a server error.



@category = (              ### *** DO NOT DISTURB THIS LINE
"Announcements,announce",
"Antiques  Collectables,antiques",
"Art/Crafts,art",
"Automotive,auto",
"Books,books",
"Business Opportunities,business_op",
"Business Services,business_sv",
"Clothing,clothing",
"Computer Hardware,comp_hardware",
"Computer Software,comp_software",
"Education,edu",
"Electronics,electronics",
"Entertainment,entertain",
"Help Wanted,helpwanted",
"Hobbies,hobby",
"Investment Oppertunities,investopp",
"Jewelry,jewelry",
"Miscellaneous,misc",
"Misc. Transportation,mist_tran",
"MLM,mlm",
"Music,music",
"Personals,personal",
"Pets,pets",
"Real Estate,realestate",
"Services Needed,svce_needed",
"Services Offered,svce_offered",
"Sports,sports",
"Travel,travel",
"Video,video",
"Wanted,wanted",
"Work at Home,workathome", 
);                         ### *** DO NOT DISTURB THIS LINE


      ### *** Sub-Routine for printing the top of all pages. *** ###

sub Page_Top {             ### *** DO NOT DISTURB THIS LINE

print <<EndOfText;

<HTML>
<HEAD>
   <TITLE>$title</TITLE>
</HEAD>
$Body
<CENTER>
<IMG SRC="$logo">
<P>
<A HREF="$listing_cgi?list=y"><IMG SRC="$Listing_Link" BORDER=0></A>
<P>
</CENTER>

EndOfText

}  ### *** DO NOT DISTURB THIS LINE ( OR 'EndOfText' ABOVE)

 
         ### *** Sub-Routine for printing the Menu. *** ###       

sub menu {     ### *** DO NOT DISTURB THIS LINE

print <<"EndOfText";

<P>
<CENTER>
<TABLE BORDER=5 CELLSPACING=0 CELLPADDING=0 $TableBg>
<TR>
 <TD>&nbsp; &nbsp;<B>Select a Category.</B> 
        <SELECT NAME="t">

EndOfText

### *** DO NOT DISTURB THE LINE ABOVE                 

foreach $key(@category) {
($Name, $FileName) = split(/,/,$key);

$FileName =~ s/\s//g;

print "<option value=\"$FileName\">$Name\n";

}  ### *** DO NOT DISTURB THIS LINE ( OR 'EndOfText' BELOW)

print "</SELECT>\n";      

if ($FORM{'list'}) {
}else{
print "<INPUT TYPE=\"submit\" VALUE=\" Go \">\n"; 
}

print "</TD>\n</TR>\n</TABLE>\n</CENTER>\n";   
        


}  ### *** DO NOT DISTURB THIS LINE 



  ### *** Sub-Routine for printing the "Nothing Found Screen". *** ###

sub no_users {      ### *** DO NOT DISTURB THIS LINE 

    print "Content-Type: text/html\n\n";

print <<"EndOfText";

<HTML>
<HEAD>
   <TITLE>$title</TITLE>
</HEAD>
$Body
<CENTER>
<IMG SRC="$logo">
<P>
<A HREF="$listing_cgi"><IMG SRC="$Listing_Link" BORDER=0></A>
<P>
<H2>There are no entries in this catagory as yet</H2>
<FORM METHOD="Post" Action="$directory_cgi">

EndOfText

&menu;

exit;
}
  ### *** DO NOT DISTURB THIS LINE ( OR 'EndOfText' ABOVE)


             ### *** DO NOT CHANGE ANYTHING BELOW *** ###

sub parse_data {

  local (*FORM) = @_ if @_;
  local ($i, $key, $val);

  # Read in text
  if (&LocalMethGet) 
  {
    $FORM = $ENV{'QUERY_STRING'};
  } 
  elsif (&LocalMethPost) 
  {
    read(STDIN,$FORM,$ENV{'CONTENT_LENGTH'});
  }

  @FORM = split(/[&;]/,$FORM); 

  foreach $i (0 .. $#FORM) 
  {
    # Convert plusses to spaces
    $FORM[$i] =~ s/\+/ /g;

    # Split into key and value
    # splits on the first =
    ($key, $val) = split(/=/,$FORM[$i],2); 

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value 
    # \0 is the multiple separator
    $FORM{$key} .= "\0" if (defined($FORM{$key})); 
    $FORM{$key} .= $val;
  }
  return scalar(@FORM);
 
} # End sub parse


sub LocalMethGet 
# from Steven Brenner's cgi-lib.pl v1.14
# true if this cgi call was using the GET request, false otherwise
{
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}

sub LocalMethPost 
# from Steven Brenner's cgi-lib.pl v1.14
# true if this cgi call was using the POST request, false otherwise
{
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}

sub open_error
    {

    local ($filename) = @_;

    print "Content-Type: text/html\n\n";


    print "
<P>
<HR>
<P>
<H1>Error!</H1>
<P>
<H4>The $this_cgi can not find, or is not able to open the 
specified file:</H4>
<H2>$filename</H2><P>  
Please check the file name.<B>";

    die;

# open (FILEHANDLE, ">>$file") || &open_error($file);

    } # End sub open_error


